# To explore all the features use the OpenSees tcl editor (in the bin
# directory) to view this file

Date: 02/20/2001

OpenSees Tcl Editor v 0.3 for Windows NT/9x, Binary Distribution.
This program is provided as is, without any warranty, and is
still in beta stage.
(Version 0.4 updated for win 2000/XP)
Authors:   Rohit Kaul
           Dr. Gregory Deierlein
           (Stanford University)

############################################################################

                             TABLE OF CONTENTS
   

    Topic                                               line number

1.  Introduction........................................... 37

2.  Installation........................................... 54

3.  Features............................................... 73

4.  Adding Help/keywords................................... 156

5.  Known Issues/bugs...................................... 173                           

6.  Bug report/comments.................................... 193

#       Line No. [] box on the dialog bar can be used to jump to the 
#                     appropriate line number.


1. Introduction:
----------------
This editor provides a convenient user interface for OpenSees
users.  It was compiled with Microsoft Visual C++ 6.0 using Win32
API.

The editor window is divided in three panes - main editor pane, command
tree view (on the left) - displaying the commands and their object types
avaiable, and the command summay pane - displaying output from context 
sensitive help. 

NOTE:
Syntax highlighting or help is provided ONLY for the keywords that are 
provided in the help files. The format for adding new keywords/help is
explained below.


2. Installation:
----------------
At startup, the program looks for C:\tcleditor\tcleditor.conf file
to get the path information.  The configuration file has the following
format:

exe E:\Programs\TclEditor\opensees.exe  
editor C:\tcleditor\bin\tcleditor.exe
bin C:\tcleditor\bin\
help C:\tcleditor\help\

where,
"exe"  -> path to opensees executable   # most often, only this has to 
                                        # be corrected in tcleditor.conf
"editor"  -> path to tcleditor.exe 
"bin" -> path to bin directory
"help" -> path to help directory, that contains all the help files. 


3. Features:
------------
* All the standard features of a text-editor: copy, paste, cut, undo...

* Can edit unlimited (practically) file size.

* Right click context menu. 

* Syntax highlighing
  # This is just a comment - greyed out
  uniaxialMaterial Concrete01
  # syntax highlights command with the object type 
  for {set i 1} {$i <= 10} {incr i 1} {playback $i}
  # syntax highlights Tcl specific keywords
  source test1.tcl
  # source files included are italicized and underlined
 
  Comments are greyed out, commands are in green, and the type (object 
  created) in blue, Tcl specific commands, like source or while are in
  different color. Source files are italicized and underlined.

  Smart:
  ------
  uniaxialMaterial truss  
  # type does not highlight unless preceded by correct command (element)
  Elastic uniaxialMaterial  
  # incorrect order - does not syntax highlight
  uniaxialMaterial Elastic
  # correct order - highlights 

* Context sensitive help
  Help for commands, object types is displayed in the command summary pane
  when, either the item is clicked in the tree view, or a command is typed
  in, or mouse is clicked on the highlighted command/object type.  Help
  is turned on by default, and it can be turned off/on by clicking on the 
  "i" button on the tool bar.
  	
  If an item from the left tree view is selected, it is copied to the 
  clipboard, which can then also be pasted by pressing the middle mouse
  button.

  Smart:
  ------
  constraints Plain
  pattern Plain
  numberer Plain 
  groundMotion Plain
  Clicking on "Plain" above, provides correct help in each case. 


* Access to variables or source-files included - from the dialog bar,
  e.g, the following variables and files appear in the drag down boxes in
  the dialog bar.  Selecting a vaiable or file name selects the line in 
  the tcl code where it appears, and the files can also be opened.
  

source examplescripts\RigidFrame3D.tcl

source examplescripts\RigidFrame3Ddisplay.tcl

source examplescripts\RCSection.tcl

  set x1 100
  set y1 200
  set dx  50

  This data appears in the dialog bar when an existing file is opened
  or when - redo sytax highlighting - "refresh button" is clicked on the
  tool bar. 

* Selection can be commented out or uncommented using right click context
  menu or the tool bar.

* For advanced printing options - click on File, Advanced Print Setup


* Running OpenSees:
  ------------------
  Opensees executable can be run to error-check or run the file, by
  clicking on the frame button on the tool bar.  This actually creates 
  "exec.bat" file that starts OpenSees.


4. Adding Help/Keywords:
------------------------ 
New OpenSEES commands can be incorporated in TclEditor through *.txt files 
located in the TclEditor help directory. Existing library *.txt files are 
identified in the list.txt file. New commands can either be added to the 
existing help files or to a new help file.  When a new library help file is
created, the file name must be identified in the list.txt file, which directs
TclEditor to look for this file. Syntax for adding new commands is as follows:  
  First line - mycommand:type, 
  e.g., 
      element:command or Truss:element 
  Subsequent lines - help information in any format.
  Final Line - Completion (separator line - containing at least one '#')

Developers can use the existing files (listed in list.txt) as examples.


5. Known Issues:
-----------------
  Syntax highlighing may not be proper in some cases, e.g, after pasting
  some text, or after keying in '#', rest of the line may not be greyed.

  For that, "redo sytax highlighting" or "syntax highlight
  current line" can be clicked from the toolbar/right mouse click.

  Printing from the Print Preview mode or File Print... menu may not work.
  Currently, it ONLY works by clicking on the print icon on the Tool bar.

  Selecting upto the end of a line (last line in case of multiple line 
  selections) and then commenting causes the next line to get commented too.

  Menu items do not reflect all the features, and key-board short cuts for
  all the menu/tool bar items are not present.

  These problems will be fixed in the next release.


6. Bug report/suggestions/comments:
-----------------------------------
  Email: rkaul@stanford.edu